/****************************************************************/
/*                                                              */
/*                       CalcInfo.c                             */
/*       Taiga Yonekura 2000 All Rights Reserved                */
/****************************************************************/
/* Rev:  DATE    : contents                      :name          */
/*----:----------:-------------------------------:--------------*/
/*     :2000/10/17: Ԋڍו\tH[    :Taiga Yonkura */
/* 1.2 :2001/03/17: Ȗڏڍ׉ʕύX              :              */
/*1.2.1:2001/03/31: oOC                      :              */
/* 1.3 :2001/04/21: n[h{^jړǉ  :              */
/*     :          :                               :              */
/****************************************************************/
#include <PalmOS.h>

#include "Comlib.h"
#include "timeRsc.h"
#include "timeTable.h"
#include "CalcInfo.h"

#define KEYWAITCALCINFO 30	//*1.3*

extern void setPushButtonDayInfo(UInt16);  //*1.3* define DayInfo.c

//static void initCalcField();
static void setFieldtxtHdl(UInt16,UInt16);
static void setFieldText(UInt16,Char*);
static void getFieldText(UInt16,Char*);
static void copyCalcInfoFormData();
static void pasteCalcInfoFormData();
static void drawStringTopLevelInfo();		/*1.2*/

static Curc *peditCurc=NULL;				/*1.2* ǉ */
static Curc copyBuff;
static Char DispTime;	/*ݕ\Ă鎞*/
static Char DispDay;	/*ݕ\Ăj*/

//*1.3*
//n[hEGAL[ꂽƂijړj
//
static void pushKeyLeft(void)
{
	if(DispDay > MONDAY){
		getCalcInfoFormData(); //*ݒf[^ۑ
		DispDay--;
	}
	
	initCalcFrm(DispDay,DispTime);
}
//*1.3*
//n[hEGAL[ꂽƂijړj
//
static void pushKeyRight(void)
{
	if(DispDay < SUNDAY){
		getCalcInfoFormData(); //*ݒf[^ۑ
		DispDay++;
	}
	
	initCalcFrm(DispDay,DispTime);
}
//*1.2* C^tF[XύX
//
//	
//void initCalcFrm(Curc *pCurc)
void initCalcFrm(Char day,Char time)
{
	Curc* pCurc = NULL;					/*1.2*/
	UInt16 upIndex;						/*1.2*/
	UInt16 downIndex;					/*1.2*/
	FormPtr frm;						/*1.2*/
	Boolean scrollableUp = true;		/*1.2*/
	Boolean scrollableDown = true;		/*1.2*/

	frm = FrmGetActiveForm();			/*1.2*/
	
	pCurc = getCurcData(day,time);		/*1.2*/
	if(pCurc == NULL) return;			/*1.2* maybe bug*/

	//initCalcField();/*1.2 R[ƓG[ɂȂ CɈړ*/
	
	peditCurc = pCurc;
	DispTime = time;					/*1.2*/
	DispDay  = day;						/*1.2*/
	
	drawStringTopLevelInfo();
	
	//\f[^Zbg
	setFieldText(CalcTypeFld,peditCurc->title);
	setFieldText(TeacherNameFld,peditCurc->teacher);
	setFieldText(ClassRoomNumFld,peditCurc->room);
	setFieldText(AddInfoFld,peditCurc->add);
	
	
	//*1.2* XN[{^̐ݒ
	upIndex = FrmGetObjectIndex (frm, RepBtnUP);
	downIndex = FrmGetObjectIndex (frm, RepBtnDown);
	if(DispTime == ONEDAYMAXCALC) scrollableDown = false;
	else if(DispTime == 1) scrollableUp = false;
	FrmUpdateScrollers (frm, upIndex, downIndex, scrollableUp, scrollableDown);
	
	//*1.3* push Button̐ݒ
	setPushButtonDayInfo((Char)DispDay);
}
//
//f[^̏
//
void initCopyBuff()
{
	copyBuff.title[0] = '\0';
	copyBuff.room[0] = '\0';
	copyBuff.teacher[0] ='\0';
	copyBuff.add[0] ='\0';
}
//
//j[Cxg
//
Boolean CalcFrmMenuEvt(UInt16 itemID)
{
	Boolean ret = false;
	
	switch(itemID){
	case COPYITEMID:
		copyCalcInfoFormData();
		ret = true;
		break;
	case PASTEITEMID:
		pasteCalcInfoFormData();
		ret = true;
		break;
	}
	
	return false;
}
//
//Ԋڍ׃f[^擾
//
void getCalcInfoFormData()
{
	
	getFieldText(CalcTypeFld,peditCurc->title);
	getFieldText(TeacherNameFld,peditCurc->teacher);
	getFieldText(ClassRoomNumFld,peditCurc->room);
	getFieldText(AddInfoFld,peditCurc->add);

}
//*1.2
//̃s[g{^ꂽ
//
void pushUpBtnCalcInfo()
{
	if(DispTime > 1) {
		getCalcInfoFormData(); //*1.2.1 ݒf[^ۑ
		DispTime--;
	}
	initCalcFrm(DispDay,DispTime);
}
//*1.2
//̃s[g{^ꂽ
//
void pushDownBtnCalcInfo()
{
	
	if(DispTime < ONEDAYMAXCALC) {
		getCalcInfoFormData(); //*1.2.1 ݒf[^ۑ
		DispTime++;
	}
	initCalcFrm(DispDay,DispTime);
}
//*1.2*
// n[h{^ǉ
//
void keyDownCalcInfoFrm()
{
	UInt32 keyType;
	
	keyType = KeyCurrentState();
	
	if (keyType & 0x02) {       	//Up
		sleepWait(KEYWAITCALCINFO);	//*1.3*
		pushUpBtnCalcInfo();
	} else if (keyType & 0x04) {	//Down
		sleepWait(KEYWAITCALCINFO);	//*1.3*
		pushDownBtnCalcInfo();
	} else if (keyType & 0x10) {	//left *1.3*
		sleepWait(KEYWAITCALCINFO);	//*1.3*
		pushKeyLeft();
	} else if (keyType & 0x20) {	//right *1.3*
		sleepWait(KEYWAITCALCINFO);	//*1.3*
		pushKeyRight();
	}
}
//*1.2*
//j̃vbV{^ꂽƂ̏
//
Boolean selectDayCalcInfo(UInt16 ctrID)
{
	Boolean ret = true;
	Char dayType = MONDAY;
	
	switch(ctrID){
		
	case DAYPUSHBTN1:
		dayType = MONDAY;
	break;
	
	case DAYPUSHBTN2:
		dayType = TUEDAY;
	break;
	
	case DAYPUSHBTN3:
		dayType = WESDAY;
	break;
	
	case DAYPUSHBTN4:
		dayType = THUDAY;
	break;
	
	case DAYPUSHBTN5:
		dayType = FRIDAY;
	break;
	
	case DAYPUSHBTN6:
		dayType = SATDAY;
	break;
	
	case DAYPUSHBTN7:
		dayType = SUNDAY;
	break;
	
	default:
		ret = false;
	}
	
	if(ret == true){
		getCalcInfoFormData();
		initCalcFrm(dayType,DispTime);
	}
	
	return ret;
}

//
//obt@ɃRs[
//
static void copyCalcInfoFormData()
{
	getFieldText(CalcTypeFld,copyBuff.title);
	getFieldText(TeacherNameFld,copyBuff.teacher);
	getFieldText(ClassRoomNumFld,copyBuff.room);
	getFieldText(AddInfoFld,copyBuff.add);
}
//
//obt@̃f[^eLXgɔfiy[Xgj
//
static void pasteCalcInfoFormData()
{
	//\f[^Zbg
	setFieldText(CalcTypeFld,copyBuff.title);
	setFieldText(TeacherNameFld,copyBuff.teacher);
	setFieldText(ClassRoomNumFld,copyBuff.room);
	setFieldText(AddInfoFld,copyBuff.add);
	
}
//
//tB[hRg[̏
//
void initCalcInfoField()
{
	setFieldtxtHdl(CalcTypeFld,FIELDSIZE);
	setFieldtxtHdl(TeacherNameFld,FIELDSIZE);
	setFieldtxtHdl(ClassRoomNumFld,FIELDSIZE);
	setFieldtxtHdl(AddInfoFld,FIELDSIZE);
	
}
//
//eLXgtB[h̃nh擾
//
static void setFieldtxtHdl(UInt16 fieldID,UInt16 size)
{
	FieldType *fld;
	MemHandle txtHdl;
	
	txtHdl = MemHandleNew(size);
	
	fld = (FieldType *)GetObjectPtr(fieldID);
	
	FldSetTextHandle(fld,txtHdl);
	
}
//
//eLXgtB[hɕ\
//
static void setFieldText(UInt16 fieldID,Char *string)
{
	FieldType *fld;
	MemHandle h;
	Char *text;
	
	
	fld = (FieldType *)GetObjectPtr(fieldID);
	
	h = FldGetTextHandle(fld);
	
	if(h){
		
		text = MemHandleLock(h);
		StrCopy(text,string);
		MemHandleUnlock(h);
		FldSetTextHandle(fld,h);
		FldDrawField(fld);
	}

}
//
//eLXgtB[h̕擾
//
static void getFieldText(UInt16 fieldID,Char *string)
{
	FieldType *fld;
	Char *text;
	
	fld = (FieldType *)GetObjectPtr(fieldID);
	
	text = FldGetTextPtr(fld);
	
	if(text != NULL){
		StrCopy(string,text);
	}

}
//*1.2*
//jƎ̕\
//
static void drawStringTopLevelInfo()
{
	Char str[30];
	Char str2[2];
	
	str[0] = '\0';
	
	getDayString(DispDay,str); /*1.2* W[*/

	appendChar(str,"j:");
	StrIToA(str2,DispTime);
	appendChar(str,str2);
	appendChar(str,"");
	
	WinDrawChars(str,StrLen(str),40,15);
}